Display_EN:
	; EN-Puls geben
	CBI	PORTA,	LCD_E
	NOP
	NOP
	NOP
	NOP
	NOP
	SBI	PORTA,	LCD_E
	RET

Display_Data:
	SBI	PORTA,	LCD_RS
	CBI	PORTA,	LCD_RW
	RJMP	Display_SendPacket
Display_Command:
	CBI	PORTA,	LCD_RS
	CBI	PORTA,	LCD_RW
	; Sendet MSB / LSB von temp ans Display
Display_SendPacket:
	MOV	temp1,	temp
	ANDI	temp1,	0b11110000
	SWAP	temp1
	OUT	PORTB,	temp1
	;RCALL	Wait1ms
	RCALL	Display_EN
	RCALL	Wait1ms

	MOV	temp1,	temp
	ANDI	temp1,	0b00001111
	;SWAP	temp1
	OUT	PORTB,	temp1
	;RCALL	Wait1ms
	RCALL	Display_EN
	RCALL	Wait1ms
	RET

Display_INIT:
	; Setzen des 4 Bit-Datenmode, Extension = 1
	LDI	temp,	0b00101100
	RCALL	Display_Command
	; 4 Zeilen Modus
	LDI	temp,	0b00001001
	RCALL	Display_Command

	; Setzen des 4 Bit-Datenmode, Extension = 0
	LDI	temp,	0b00101000
	RCALL	Display_Command
	; Display an, Cursor aus
	LDI	temp,	0b00001100
	RCALL	Display_Command
	; Cursor auto increment
	LDI	temp,	0b00000110
	RCALL	Display_Command
	; Cursor home, Clear display
	LDI	temp,	0b00000001
	RCALL	Display_Command
	RCALL	Wait10ms


	RET

Display_POWERUP:
	ldi	temp,	50
	powerupwait:
		rcall	Wait5ms
		dec	temp
		brne	powerupwait
	CBI	PORTA,	LCD_RS
	CBI	PORTA,	LCD_RW
	ldi	temp,	0b00000011        ;muss 3mal hintereinander gesendet
	out	PORTB,	temp              ;werden zur Initialisierung
	rcall	Display_EN
	rcall	Wait5ms
	rcall	Display_EN
	rcall	Wait5ms
	rcall	Display_EN
	rcall	Wait5ms

	ldi	temp,	0b00000010        ;4bit-Modus einstellen
	out	PORTB,	temp
	rcall	Wait5ms
	rcall	Display_EN
	rcall	Wait5ms
	RET

Display_Text:
	; Vorher muss ZL / ZH auf den Textblock eingestellt sein 
	; und der Cursor am Display richtig gesetzt sein
	DW_outp:
		LPM	; LPM instruction, it loads a byte from mem to R0
		MOV	temp,	r0
		TST	temp ; Check for nul termination
		BRNE	DW_outp1
		RET	; String fertig gesendet
	DW_outp1:
		RCALL	Display_Data
		ADIW	ZL,	1 ; point to next character
		RJMP	DW_outp
	RET

Display_Text20:
	; Vorher muss ZL / ZH auf den Textblock eingestellt sein 
	; und der Cursor am Display richtig gesetzt sein
	LDI	TEMP2, 21
	DW20_outp:
		LPM	; LPM instruction, it loads a byte from mem to R0
		MOV	temp,	r0
		DEC	TEMP2
		TST	temp2 ; Check for nul termination
		BRNE	DW20_outp1
		RET	; String fertig gesendet
	DW20_outp1:
		RCALL	Display_Data
		ADIW	ZL,	1 ; point to next character
		RJMP	DW20_outp
	RET

Display_Text6:
	; Vorher muss ZL / ZH auf den Textblock eingestellt sein 
	; und der Cursor am Display richtig gesetzt sein
	LDI	TEMP2, 7
	DW6_outp:
		LD	TEMP,Z+
		DEC	TEMP2
		TST	temp2 ; Check for nul termination
		BRNE	DW6_outp1
		RET	; String fertig gesendet
	DW6_outp1:
		RCALL	Display_Data
		RJMP	DW6_outp
	RET


Display_Screen:
	RCALL	Display_Z1
	RCALL	Display_Text20
	RCALL	Display_Z2
	RCALL	Display_Text20
	RCALL	Display_Z3
	RCALL	Display_Text20
	RCALL	Display_Z4
	RCALL	Display_Text20
	RET

Display_Z1:
	LDI	temp,	$00
	SBR	TEMP,	0b10000000
	RCALL	Display_Command
	RET

Display_Z2:
	LDI	temp,	$20
	SBR	TEMP,	0b10000000
	RCALL	Display_Command
	RET

Display_Z3:
	LDI	temp,	$40
	SBR	TEMP,	0b10000000
	RCALL	Display_Command
	RET

Display_Z4:
	LDI	temp,	$60
	SBR	TEMP,	0b10000000
	RCALL	Display_Command
	RET

Display_Zeile:
	SBR	TEMP,	0b10000000
	RCALL	Display_Command
	RET	
