SHOW_MENU:
	;RCALL	SHOW_DEBUG

	; show the current menu setting
	LDI		TEMP,	$60+8
	RCALL	Display_Zeile
	LDI		TEMP,	' '
	SBRC	MENU,	7
		LDI	TEMP,	'>'
	RCALL	Display_Data
	RCALL	Display_Data
	SM_1:
		CPI	MENU,	1
		BRNE	SM_2
		LDI	ZH, HIGH(M_1*2)
		LDI	ZL,  LOW(M_1*2)
		RJMP	SM_OK
	SM_2:
		CPI	MENU,	2
		BRNE	SM_10_16
		LDI	ZH, HIGH(M_2*2)
		LDI	ZL,  LOW(M_2*2)
		RJMP	SM_OK
	SM_10_16:
		MOV	TEMP,	MENU
		ANDI	TEMP,	0b01111111
		LDI	ZH, HIGH(M_10*2)
		LDI	ZL,  LOW(M_10*2)
		SUBI	TEMP,	10	; Menu 10 = 0
		SM_LOOP:
			TST	TEMP
			BREQ	SM_OK
			ADIW	ZH:ZL, 12	; Switch Z to next Menu Entry text	
			DEC		TEMP
			RJMP	SM_LOOP
	SM_OK:	
		RCALL	Display_Text
	SM_EXIT:
	RET


MENU_OK:
	;RCALL	SHOW_DEBUG
	MENU_1:
		CPI		MENU,	1
		BRNE	MENU_2
		RCALL	SWITCH_WAVE
		RJMP	MENU_OK_EXIT
	MENU_2:
		CPI		MENU,	2
		BRNE	MENU_10_16
		LDI		MENU,	10
		RJMP	MENU_OK_EXIT
	MENU_10_16:
		MOV		TEMP,	MENU
		ANDI	TEMP,	0b01111111
		CPI		TEMP,	16
		BREQ	MENU_16
		SBRS	MENU,	7	; Control Bit 1?
			RJMP	MENU_OK_ON
		CBR		MENU,	0b10000000
		RJMP	MENU_OK_EXIT
		MENU_OK_ON:
			SBR		MENU,	0b10000000
			RJMP	MENU_OK_EXIT
	MENU_16:
		LDI		MENU,	1
		RJMP	MENU_OK_EXIT

	MENU_OK_EXIT:
		RCALL	SHOW_MENU

	MENU_OK_LOOP:
		RCALL	Wait5ms
		SBIS	PINE,	ROT_BTN
		RJMP	MENU_OK_LOOP
	RET


; add 1 to the phase accumulator		
up_1:
		adiw	FREQ_M:FREQ_L	,	1	
		clr		TEMP
		adc		FREQ_H,	TEMP
		RET
; add 10 to the phase accumulator		
up_10:
		adiw	FREQ_M:FREQ_L	,	10
		clr		TEMP
		adc		FREQ_H,	TEMP
		RET
; add 100 to the phase accumulator		
up_100:
		ldi		TEMP	,	0x64
		add		FREQ_L	, 	TEMP
		clr		TEMP
		adc		FREQ_M	,	TEMP
		adc		FREQ_H	,	TEMP
		RET
up_1000:
		RCALL	up_100
		RCALL	up_100
		RCALL	up_100
		RCALL	up_100
		RCALL	up_100
		RCALL	up_100
		RCALL	up_100
		RCALL	up_100
		RCALL	up_100
		RCALL	up_100
		RET
up_10000:
		RCALL	up_1000
		RCALL	up_1000
		RCALL	up_1000
		RCALL	up_1000
		RCALL	up_1000
		RCALL	up_1000
		RCALL	up_1000
		RCALL	up_1000
		RCALL	up_1000
		RCALL	up_1000
		RET
up_100000:
		RCALL	up_10000
		RCALL	up_10000
		RCALL	up_10000
		RCALL	up_10000
		RCALL	up_10000
		RCALL	up_10000
		RCALL	up_10000
		RCALL	up_10000
		RCALL	up_10000
		RCALL	up_10000
		RET

MENU_INC:
	; increment menu
	MOV		TEMP,	MENU
	ANDI	TEMP,	0b01111111
	MI_1:
		CPI		TEMP,	1
		BRNE	MI_2
		LDI		MENU,	2
		RJMP	MENU_INC_OK
	MI_2:
		CPI		TEMP,	2
		BRNE	MI_10_16
		LDI		MENU,	1
		RJMP	MENU_INC_OK

	MI_10_16:
		CPI		TEMP,	16
		BREQ	MI_10_16_CYCLE
		; Action flag = 1???
		SBRS	MENU,	7
			RJMP	MI_10_16_CYCLE
		; Okay, we are in action state - modify frequency
		MI_10:	CPI	TEMP,	10
			BRNE	MI_11
			RCALL	up_1
			RJMP	MENU_INC_RETURN
		MI_11:	CPI	TEMP,	11
			BRNE	MI_12
			RCALL	up_10
			RJMP	MENU_INC_RETURN
		MI_12:	CPI	TEMP,	12
			BRNE	MI_13
			RCALL	up_100
			RJMP	MENU_INC_RETURN
		MI_13:	CPI	TEMP,	13
			BRNE	MI_14
			RCALL	up_1000
			RJMP	MENU_INC_RETURN
		MI_14:	CPI	TEMP,	14
			BRNE	MI_15
			RCALL	up_10000
			RJMP	MENU_INC_RETURN
		MI_15:	CPI	TEMP,	15
			BRNE	MENU_INC_RETURN
			RCALL	up_100000
			RJMP	MENU_INC_RETURN

		MENU_INC_RETURN:
			LDI	TEMP,'s'
			RCALL	UART_TX
			MOV	TEMP,	FREQ_H
			RCALL	UART_TX
			MOV	TEMP,	FREQ_M
			RCALL	UART_TX
			MOV	TEMP,	FREQ_L
			RCALL	UART_TX
		
			RCALL	SHOW_PHASE
		
		RJMP	MENU_INC_EXIT	
	MI_10_16_CYCLE:
		; We're not in action, so modify submenu setting
		INC	TEMP
		MOV	MENU,	TEMP
		CPI	MENU,	17
		BRNE	MENU_INC_OK
		LDI	MENU,	10
	MENU_INC_OK:
		RCALL	SHOW_MENU
	MENU_INC_EXIT:
	RET


; subtract 1 from the phase accumulator		
down_1:
		sbiw	FREQ_M:FREQ_L	,	1	
		clr		TEMP
		sbc		FREQ_H,	TEMP
		RET
; subtract 10 from the phase accumulator		
down_10:
		sbiw	FREQ_M:FREQ_L	,	10
		clr		TEMP
		sbc		FREQ_H,	TEMP
		RET
; subtract 100 from the phase accumulator		
down_100:
		subi	FREQ_L	, 	0x64
		clr		TEMP
		sbc		FREQ_M	,	TEMP
		sbc		FREQ_H	,	TEMP
		RET
down_1000:
		RCALL	down_100
		RCALL	down_100
		RCALL	down_100
		RCALL	down_100
		RCALL	down_100
		RCALL	down_100
		RCALL	down_100
		RCALL	down_100
		RCALL	down_100
		RCALL	down_100
		RET
down_10000:
		RCALL	down_1000
		RCALL	down_1000
		RCALL	down_1000
		RCALL	down_1000
		RCALL	down_1000
		RCALL	down_1000
		RCALL	down_1000
		RCALL	down_1000
		RCALL	down_1000
		RCALL	down_1000
		RET
down_100000:
		RCALL	down_10000
		RCALL	down_10000
		RCALL	down_10000
		RCALL	down_10000
		RCALL	down_10000
		RCALL	down_10000
		RCALL	down_10000
		RCALL	down_10000
		RCALL	down_10000
		RCALL	down_10000
		RET



MENU_DEC:
	; decrement menu
	MOV		TEMP,	MENU
	ANDI	TEMP,	0b01111111
	MD_1:
		CPI		TEMP,	1
		BRNE	MD_2
		LDI		MENU,	2
		RJMP	MENU_DEC_OK
	MD_2:
		CPI		TEMP,	2
		BRNE	MD_10_16
		LDI		MENU,	1
		RJMP	MENU_DEC_OK

	MD_10_16:
		CPI		TEMP,	16
		BREQ	MD_10_16_CYCLE
		; Action flag = 1???
		SBRS	MENU,	7
			RJMP	MD_10_16_CYCLE
		; Okay, we are in action state - modify frequency
		MD_10:	CPI	TEMP,	10
			BRNE	MD_11
			RCALL	down_1
			RJMP	MENU_DEC_RETURN
		MD_11:	CPI	TEMP,	11
			BRNE	MD_12
			RCALL	down_10
			RJMP	MENU_DEC_RETURN
		MD_12:	CPI	TEMP,	12
			BRNE	MD_13
			RCALL	down_100
			RJMP	MENU_DEC_RETURN
		MD_13:	CPI	TEMP,	13
			BRNE	MD_14
			RCALL	down_1000
			RJMP	MENU_DEC_RETURN
		MD_14:	CPI	TEMP,	14
			BRNE	MD_15
			RCALL	down_10000
			RJMP	MENU_DEC_RETURN
		MD_15:	CPI	TEMP,	15
			BRNE	MENU_DEC_RETURN
			RCALL	down_100000
			RJMP	MENU_DEC_RETURN
		MENU_DEC_RETURN:
			LDI	TEMP,'s'
			RCALL	UART_TX
			MOV	TEMP,	FREQ_H
			RCALL	UART_TX
			MOV	TEMP,	FREQ_M
			RCALL	UART_TX
			MOV	TEMP,	FREQ_L
			RCALL	UART_TX
		
			RCALL	SHOW_PHASE
		
		RJMP	MENU_DEC_EXIT	
	MD_10_16_CYCLE:
		; We're not in action, so modify submenu setting
		DEC	TEMP
		MOV	MENU,	TEMP
		CPI	MENU,	9
		BRNE	MENU_DEC_OK
		LDI	MENU,	16
	MENU_DEC_OK:
		RCALL	SHOW_MENU
	MENU_DEC_EXIT:
	RET
