.INCLUDE	"m8515def.inc"

.DEF	DV_LAST =	R15
.DEF	TEMP	=	R16
.DEF	TEMP1	=	R17
.DEF	TEMP2	=	R18
.DEF	DV_STEP =	R19
.DEF	WAVE	=	R20
.DEF	MENU	=	R21

.DEF	FREQ_L	=	R24
.DEF	FREQ_M	=	R25
.DEF	FREQ_H	=	R26



.EQU	LCD_E	= 2 ; PA
.EQU	LCD_RS	= 0 ; PA
.EQU	LCD_RW	= 1 ; PA

.EQU	ROT_A	= 0 ; PE
.EQU	ROT_B	= 2 ; PE
.EQU	ROT_BTN	= 1 ; PE

.EQU	NUL		= 0

;	f = deltaPhase * fClock/2^24
;
;   fClock is in this case the CPU clock divided by the
;	number of cycles to output the data ( 9 cycles )
;
;	f = r24/r25/r26 * (11059200/9)/16777216
;
;	f = r24/r25/r26 * 0.073242188
;
;	fMax (theoretical) = 0.5 * fClock
;
;.EQU XTAL 	= 16000000
;.EQU CLOCK 	= XTAL / 9 
;.EQU FMAX 	= CLOCK / 2
;.EQU FACTOR = CLOCK / 16777216

.DSEG
STR6: .byte 6

.CSEG

;.ORG $0
;RJMP	RESET
;.ORG $0D*2
;RJMP	INT_2
;.ORG $07*2
;RJMP	TIMER0
;.ORG $09*2
;RJMP	UART_RX

.ORG 0
 rjmp RESET ; Reset Handler
 RETI;rjmp EXT_INT0 ; IRQ0 Handler
 RETI;rjmp EXT_INT1 ; IRQ1 Handler
 RETI;rjmp TIM1_CAPT ; Timer1 Capture Handler
 RETI;rjmp TIM1_COMPA ; Timer1 Compare A Handler
 RETI;rjmp TIM1_COMPB ; Timer1 Compare B Handler
 RETI;rjmp TIM1_OVF ; Timer1 Overflow Handler
 RETI;rjmp TIM0_OVF ; Timer0 Overflow Handler
 RETI;rjmp SPI_STC ; SPI Transfer Complete Handler
 rjmp UART_RX ; USART RX Complete Handler
 RETI;rjmp USART_UDRE ; UDR0 Empty Handler
 RETI;rjmp USART_TXC ; USART TX Complete Handler
 RETI;rjmp ANA_COMP ; Analog Comparator Handler
 RETI;rjmp EXT_INT2 ; IRQ2 Handler
 RETI;rjmp TIM0_COMP ; Timer0 Compare Handler
 RETI;rjmp EE_RDY ; EEPROM Ready Handler
 RETI;rjmp SPM_RDY ; Store Program memory Ready


.ORG 100
EncTbl:	
.db	1,3,0,2

.ORG 256
M_1: .db "  WAVEFORM",nul,nul
M_2: .db " FREQUENCY",nul,nul
M_10:.db "FREQ  FINE",nul,nul
M_11:.db "FREQ   1Hz",nul,nul
M_12:.db "FREQ  10Hz",nul,nul
M_13:.db "FREQ 100Hz",nul,nul
M_14:.db "FREQ  1KHz",nul,nul
M_15:.db "FREQ 10KHz",nul,nul
M_16:.db "MENU  BACK",nul,nul

Screen_Layout:
.DB "Waveform:           " 
.DB "Phase Adder:        "
.DB "                    "
.DB "Menu:               ",nul,nul


T_1: .db "    SINE",nul,nul
T_2: .db "SAWTOOTH",nul,nul
T_3: .db "TRIANGLE",nul,nul
T_4: .db "  SQUARE",nul,nul


.INCLUDE "LCD4BIT.ASM"
.INCLUDE "DELAYS.ASM"
;.INCLUDE "DIV24.ASM"
.INCLUDE "BIN2HEX.ASM"
.INCLUDE "MENU.ASM"
.INCLUDE "UART.ASM"

RESET:
	LDI	TEMP,	LOW(RAMEND)
	OUT	SPL,	TEMP
	LDI	TEMP,	HIGH(RAMEND)
	OUT	SPH,	TEMP

	SER	TEMP
	OUT	DDRA,	TEMP
	OUT	DDRB,	TEMP
	OUT	PORTB,	TEMP
	OUT	PORTA,	TEMP
	CLR	TEMP
	OUT	DDRE,	TEMP
	SER TEMP
	OUT	PORTE,	TEMP

	LDI		FREQ_L, $00
	LDI		FREQ_M, $00
	LDI		FREQ_H, $00
	CLR	DV_STEP
	LDI	WAVE,1
	LDI	MENU,1



	RCALL	Display_POWERUP
	RCALL	Display_INIT

	LDI	ZL,LOW(2*Screen_Layout)
	LDI	ZH,HIGH(2*Screen_Layout)
	RCALL	Display_Screen

	RCALL	SHOW_WAVE
	RCALL	SHOW_PHASE
	RCALL	SHOW_MENU

	; PE Interrupt
	;LDI	TEMP,0b00100000
	;OUT	GICR,	TEMP
	;LDI	TEMP,	0b00000001
	;OUT EMCUCR,	TEMP

	;LDI	TEMP,	0b00000001
	;OUT	TCCR0,	TEMP
	;LDI	TEMP,	0b00000010
	;OUT	TIMSK,	TEMP

	CLR	TEMP
	OUT	UBRRH,	TEMP
	ldi		r16,0x01		; set uart speed to 1Mbps
	out		UBRRL,r16
	ldi		r16,0b10011000		; enable RXint and enable tx/rx
	out		UCSRB,r16

	SEI

LOOP:

	RCALL	Wait5ms

	; check button
	SBIS	PINE,	ROT_BTN
		RCALL	MENU_OK

	RCALL	ROTARY

	RJMP	LOOP


SHOW_WAVE:
	; SHows current waveform setting
	SWF1:
		CPI	WAVE,	1
		BRNE	SWF2
		LDI	ZH, HIGH(T_1*2)
		LDI	ZL,  LOW(T_1*2)
		RJMP	SWF_OK
	SWF2:
		CPI	WAVE,	2
		BRNE	SWF3
		LDI	ZH, HIGH(T_2*2)
		LDI	ZL,  LOW(T_2*2)
		RJMP	SWF_OK
	SWF3:
		CPI	WAVE,	3
		BRNE	SWF4
		LDI	ZH, HIGH(T_3*2)
		LDI	ZL,  LOW(T_3*2)
		RJMP	SWF_OK
	SWF4:
		CPI	WAVE,	4
		BRNE	SWF_EXIT
		LDI	ZH, HIGH(T_4*2)
		LDI	ZL,  LOW(T_4*2)
	SWF_OK:	
		LDI		TEMP,	$00+12
		RCALL	Display_Zeile
		RCALL	Display_Text
	SWF_EXIT:
	RET

SWITCH_WAVE:
	DEC	WAVE
	TST	WAVE
	BRNE	WAVE_SET
	LDI	WAVE,	4
	WAVE_SET:
	MOV	TEMP,	WAVE
	LDI	TEMP1,	'0'
	ADD	TEMP,	TEMP1
	RCALL	UART_TX

	RCALL	SHOW_WAVE
	RET

SHOW_Phase:
	; SHows current frequency phase setting
	RCALL	FREQ2HEX
	LDI		TEMP,	$20+14
	RCALL	Display_Zeile
	RCALL	Display_Text6
	RET

INT_2:

	RETI

TIMER0:
	PUSH	TEMP
	IN TEMP,SREG
	PUSH	TEMP

	CLR		TEMP
	OUT		TCNT0,	TEMP

	POP	TEMP
	OUT SREG,TEMP
	POP	TEMP
	RETI

ROTARY:
	IN		TEMP,	PINE
	MOV		TEMP1,	TEMP
	ANDI	TEMP1,	0b00000100
	CBR		TEMP,	0b00000010
	TST		TEMP1
	BREQ	ROTARY_2
	SBR		TEMP,	0b00000010
	ROTARY_2:
	ANDI	TEMP,	0b00000011

	CP		TEMP,	DV_LAST
	BREQ	ROTARY_EXIT


	MOV		TEMP2,	DV_LAST
	MOV		DV_LAST,	TEMP

	ldi		ZL,LOW(EncTbl*2)			; load address of table w old states
	ldi		ZH,HIGH(EncTbl*2)
	add		ZL, temp					; add index
	lpm		temp, Z
	cp		temp, temp2					; compare w prev status
	breq	StepNeg						; ok, found neg Step
	
	com		temp						; reverse test
	andi	temp, 0b00000011
	ldi		ZL,LOW(EncTbl*2)			; load address of table w old states
	ldi		ZH,HIGH(EncTbl*2)
	add		ZL, temp					; add index
	cp		temp, temp2					; compare w prev status
	breq	StepPos
	
	RET
	
	StepNeg:
		TST	TEMP
		BREQ	StepNegOK
		CPI	TEMP, 0b00000011
		BREQ	StepNegOK
		RET
		StepNegOK:
		;Rechts gedreht
		LDI	DV_STEP, 2
		RCALL	MENU_INC
		RET
	
	StepPos:
		com		temp						; reverse test
		andi	temp, 0b00000011
		TST	TEMP
		BREQ	StepPosOK
		CPI	TEMP, 0b00000011
		BREQ	StepPosOK
		RET
		StepPosOK:
		;Links gedreht
		LDI	DV_STEP, 1
		RCALL	MENU_DEC
		RET	


	ROTARY_EXIT:
	RET

SHOW_DEBUG:
	LDI		ZH,	HIGH(STR6)
	LDI		ZL,	LOW(STR6)
	LDI		TEMP,	$40
	RCALL	Display_Zeile

	MOV		TEMP,	MENU
	RCALL	Bin1ToHex2
	sbiw ZL,2 ; Zeiger auf Anfang Hex-ASCII
	RCALL	Display_Text6
	RET






